Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Class FastTreeMap

    java.lang.Object
      java.util.AbstractMap
          java.util.TreeMap
              org.apache.commons.collections.FastTreeMap

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, java.util.Map, java.util.SortedMap

    public class FastTreeMap

extends java.util.TreeMap

A customized implementation of `java.util.TreeMap` designed to operate in a multithreaded environment where the large majority of method calls are read-only, instead of structural changes. When operating in "fast" mode, read calls are non-synchronized and write calls perform the following steps:

- Clone the existing collection
- Perform the modification on the clone
- Replace the existing collection with the (modified) clone

When first created, objects of this class default to "slow" mode, where all accesses of any type are synchronized but no cloning takes place. This is appropriate for initially populating the collection, followed by a switch to "fast" mode (by calling `setFast(true)`) after initialization is complete.

NOTE: If you are creating and accessing a `TreeMap` only within a single thread, you should use `java.util.TreeMap` directly (with no synchronization), for maximum performance.

NOTE: This class is not cross-platform. Using it may cause unexpected failures on some architectures. It suffers from the same problems as the double-checked locking idiom. In particular, the instruction that clones the internal collection and the instruction that sets the internal reference to the clone can be executed or perceived out-of-order. This means that any read operation might fail unexpectedly, as it may be reading the state of the internal collection before the internal collection is fully formed. For more information on the double-checked locking idiom, see the Double-Checked Locking Idiom Is Broken Declaration.

Since:
  Commons Collections 1.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Craig R. McClanahan, Stephen Colebourne
See Also:
  Serialized Form

Field Summary
`protected boolean` | `fast` Are we operating in "fast" mode?
`protected java.util.TreeMap` | `map` The underlying map we are managing.

Constructor Summary
`FastTreeMap()` Construct a an empty map.
`FastTreeMap(java.util.Comparator comparator)` Construct an empty map with the specified comparator.
`FastTreeMap(java.util.Map map)` Construct a new map with the same mappings as the specified map, sorted according to the keys's natural order
`FastTreeMap(java.util.SortedMap map)` Construct a new map with the same mappings as the specified map, sorted according to the same ordering

Method Summary
`void` | `clear()` Remove all mappings from this map.
`java.lang.Object` | `clone()` Return a shallow copy of this `FastTreeMap` instance.
`java.util.Comparator` | `comparator()` Return the comparator used to order this map, or `null` if this map uses its keys' natural order.
`boolean` | `containsKey(java.lang.Object key)` Return `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(java.lang.Object value)` Return `true` if this map contains one or more keys mapping to the specified value.
`java.util.Set` | `entrySet()` Return a collection view of the mappings contained in this map.
`boolean` | `equals(java.lang.Object o)` Compare the specified object with this list for equality.
`java.lang.Object` | `firstKey()` Return the first (lowest) key currently in this sorted map.
`java.lang.Object` | `get(java.lang.Object key)` Return the value to which this map maps the specified key.
`boolean` | `getFast()` Returns true if this map is operating in fast mode.
`int` | `hashCode()` Return the hash code value for this map.
`java.util.SortedMap` | `headMap(java.lang.Object key)` Return a view of the portion of this map whose keys are strictly less than the specified key.
`boolean` | `isEmpty()` Return `true` if this map contains no mappings.
`java.util.Set` | `keySet()` Return a set view of the keys contained in this map.
`java.lang.Object` | `lastKey()` Return the last (highest) key currently in this sorted map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Associate the specified value with the specified key in this map.
`void` | `putAll(java.util.Map in)` Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.
`java.lang.Object` | `remove(java.lang.Object key)` Remove any mapping for this key, and return any previously mapped value.
`void` | `setFast(boolean fast)` Sets whether this map is operating in fast mode.
`int` | `size()` Return the number of key-value mappings in this map.
`java.util.SortedMap` | `subMap(java.lang.Object fromKey, java.lang.Object toKey)` Return a view of the portion of this map whose keys are in the range fromKey (inclusive) to toKey (exclusive).
`java.util.SortedMap` | `tailMap(java.lang.Object key)` Return a view of the portion of this map whose keys are greater than or equal to the specified key.
`java.util.Collection` | `values()` Return a collection view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### map

    protected java.util.TreeMap map

  The underlying map we are managing.

### fast

    protected boolean fast

  Are we operating in "fast" mode?

Constructor Detail

### FastTreeMap

    public FastTreeMap()

  Construct a an empty map.

### FastTreeMap

    public FastTreeMap(java.util.Comparator comparator)

  Construct an empty map with the specified comparator.

  Parameters:
    `comparator` - the comparator to use for ordering tree elements

### FastTreeMap

    public FastTreeMap(java.util.Map map)

  Construct a new map with the same mappings as the specified map, sorted according to the keys's natural order

  Parameters:
    `map` - the map whose mappings are to be copied

### FastTreeMap

    public FastTreeMap(java.util.SortedMap map)

  Construct a new map with the same mappings as the specified map, sorted according to the same ordering

  Parameters:
    `map` - the map whose mappings are to be copied

Method Detail

### getFast

    public boolean getFast()

  Returns true if this map is operating in fast mode.

  Returns:
    true if this map is operating in fast mode

### setFast

    public void setFast(boolean fast)

  Sets whether this map is operating in fast mode.

  Parameters:
    `fast` - true if this map should operate in fast mode

### get

    public java.lang.Object get(java.lang.Object key)

  Return the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key, or if there is a mapping with a value of `null`. Use the `containsKey()` method to disambiguate these cases.

  Specified by:
    `get` in interface `java.util.Map`
  Overrides:
    `get` in class `java.util.TreeMap`
  Parameters:
    `key` - the key whose value is to be returned
  Returns:
    the value mapped to that key, or null

### size

    public int size()

  Return the number of key-value mappings in this map.

  Specified by:
    `size` in interface `java.util.Map`
  Overrides:
    `size` in class `java.util.TreeMap`
  Returns:
    the current size of the map

### isEmpty

    public boolean isEmpty()

  Return `true` if this map contains no mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map`
  Overrides:
    `isEmpty` in class `java.util.AbstractMap`
  Returns:
    is the map currently empty

### containsKey

    public boolean containsKey(java.lang.Object key)

  Return `true` if this map contains a mapping for the specified key.

  Specified by:
    `containsKey` in interface `java.util.Map`
  Overrides:
    `containsKey` in class `java.util.TreeMap`
  Parameters:
    `key` - the key to be searched for
  Returns:
    true if the map contains the key

### containsValue

    public boolean containsValue(java.lang.Object value)

  Return `true` if this map contains one or more keys mapping to the specified value.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Overrides:
    `containsValue` in class `java.util.TreeMap`
  Parameters:
    `value` - the value to be searched for
  Returns:
    true if the map contains the value

### comparator

    public java.util.Comparator comparator()

  Return the comparator used to order this map, or `null` if this map uses its keys' natural order.

  Specified by:
    `comparator` in interface `java.util.SortedMap`
  Overrides:
    `comparator` in class `java.util.TreeMap`
  Returns:
    the comparator used to order the map, or null if natural order

### firstKey

    public java.lang.Object firstKey()

  Return the first (lowest) key currently in this sorted map.

  Specified by:
    `firstKey` in interface `java.util.SortedMap`
  Overrides:
    `firstKey` in class `java.util.TreeMap`
  Returns:
    the first key in the map

### lastKey

    public java.lang.Object lastKey()

  Return the last (highest) key currently in this sorted map.

  Specified by:
    `lastKey` in interface `java.util.SortedMap`
  Overrides:
    `lastKey` in class `java.util.TreeMap`
  Returns:
    the last key in the map

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Associate the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced and returned.

  Specified by:
    `put` in interface `java.util.Map`
  Overrides:
    `put` in class `java.util.TreeMap`
  Parameters:
    `key` - the key with which the value is to be associated
    `value` - the value to be associated with this key
  Returns:
    the value previously mapped to the key, or null

### putAll

    public void putAll(java.util.Map in)

  Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.

  Specified by:
    `putAll` in interface `java.util.Map`
  Overrides:
    `putAll` in class `java.util.TreeMap`
  Parameters:
    `in` - the map whose mappings are to be copied

### remove

    public java.lang.Object remove(java.lang.Object key)

  Remove any mapping for this key, and return any previously mapped value.

  Specified by:
    `remove` in interface `java.util.Map`
  Overrides:
    `remove` in class `java.util.TreeMap`
  Parameters:
    `key` - the key whose mapping is to be removed
  Returns:
    the value removed, or null

### clear

    public void clear()

  Remove all mappings from this map.

  Specified by:
    `clear` in interface `java.util.Map`
  Overrides:
    `clear` in class `java.util.TreeMap`

### equals

    public boolean equals(java.lang.Object o)

  Compare the specified object with this list for equality. This implementation uses exactly the code that is used to define the list equals function in the documentation for the `Map.equals` method.

  Specified by:
    `equals` in interface `java.util.Map`
  Overrides:
    `equals` in class `java.util.AbstractMap`
  Parameters:
    `o` - the object to be compared to this list
  Returns:
    true if the two maps are equal

### hashCode

    public int hashCode()

  Return the hash code value for this map. This implementation uses exactly the code that is used to define the list hash function in the documentation for the `Map.hashCode` method.

  Specified by:
    `hashCode` in interface `java.util.Map`
  Overrides:
    `hashCode` in class `java.util.AbstractMap`
  Returns:
    a suitable integer hash code

### clone

    public java.lang.Object clone()

  Return a shallow copy of this `FastTreeMap` instance. The keys and values themselves are not copied.

  Overrides:
    `clone` in class `java.util.TreeMap`
  Returns:
    a clone of this map

### headMap

    public java.util.SortedMap headMap(java.lang.Object key)

  Return a view of the portion of this map whose keys are strictly less than the specified key.

  Specified by:
    `headMap` in interface `java.util.SortedMap`
  Overrides:
    `headMap` in class `java.util.TreeMap`
  Parameters:
    `key` - Key higher than any in the returned map
  Returns:
    a head map

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Return a view of the portion of this map whose keys are in the range fromKey (inclusive) to toKey (exclusive).

  Specified by:
    `subMap` in interface `java.util.SortedMap`
  Overrides:
    `subMap` in class `java.util.TreeMap`
  Parameters:
    `fromKey` - Lower limit of keys for the returned map
    `toKey` - Upper limit of keys for the returned map
  Returns:
    a sub map

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object key)

  Return a view of the portion of this map whose keys are greater than or equal to the specified key.

  Specified by:
    `tailMap` in interface `java.util.SortedMap`
  Overrides:
    `tailMap` in class `java.util.TreeMap`
  Parameters:
    `key` - Key less than or equal to any in the returned map
  Returns:
    a tail map

### entrySet

    public java.util.Set entrySet()

  Return a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`.

  Specified by:
    `entrySet` in interface `java.util.Map`
  Overrides:
    `entrySet` in class `java.util.TreeMap`

### keySet

    public java.util.Set keySet()

  Return a set view of the keys contained in this map.

  Specified by:
    `keySet` in interface `java.util.Map`
  Overrides:
    `keySet` in class `java.util.TreeMap`

### values

    public java.util.Collection values()

  Return a collection view of the values contained in this map.

  Specified by:
    `values` in interface `java.util.Map`
  Overrides:
    `values` in class `java.util.TreeMap`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.